<?php
/* 
 * based on mpd remote - xhtml-mp interface to mpd
 * version 1.2 - 2006-jan-07
 * copyright (c) 2004-2006 thomas e. morgan
 * http://iprog.com/mpdremote
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */ 

 /*
 	dot = (a & 2) >> 1;
	shuffle = (a & 4) >> 2;
	dash = (a & 8) >> 3;
	repeat = (a & 16) >> 4;
	repeatone = (a & 32) >> 5;
	playsymbol = (a & 64) >> 6;
 */
error_reporting(E_ALL & ~E_NOTICE & ~E_DEPRECATED);
 
// configuration //
//   (config also in playlist.php)
$host = 'oaserver';
$host = 'localhost';
$port = 6600;
$password = null;

require_once('mpd-class/mpd.class.php');

$mpd = new mpd($host,$port,$password);
while(1) {
	$mpd->RefreshInfo();
	$extrachar = 1;
	if($mpd->repeat)
			$extrachar |= 16;
		if($mpd->random)
			$extrachar |= 4;
	
	switch ($mpd->state) {
		case MPD_STATE_PLAYING : $stat = 'Playing: '; break;
		case MPD_STATE_STOPPED : $stat = 'Stopped'; break;
		case MPD_STATE_PAUSED  : $stat = 'Paused: '; break;
		default : $stat = 'Unknown status';
	}
	
	if($volold != $mpd->volume) {
		$voltimeout = 5;
		$vol = $mpd->volume > 99 ? 99 : $mpd->volume;
	}
	$volold = $mpd->volume;
	
	if($voltimeout > 0) {
		$cmd = sprintf('./lcd2usb vol-%02d ',$vol).sprintf('%c',$extrachar);
		printf($cmd."\n");
		shell_exec($cmd);
		$voltimeout--;
	}
	else {
		if ($mpd->state == MPD_STATE_PLAYING || $mpd->state == MPD_STATE_PAUSED) {
			$tracknr = intval($mpd->playlist[$mpd->current_track_id]["Track"]);
			
			$trackmin = intval(floor($mpd->current_track_position/60));
			$tracksec = intval($mpd->current_track_position%60);
			
			$trackinfo = sprintf('%02d%02d%02d', $tracknr, $trackmin, $tracksec);
			$extrachar |= 10; // dash + dot
			
			if($mpd->state == MPD_STATE_PAUSED) {
				if($a > 4) {
					$a = 0;
				}
				else {
					$a++;
				}
				if($a < 3) {
					$extrachar |= 64;
				}
			}
			else {
				//playing
				$extrachar |= 64;
			}
			
		//    var_dump($mpd);
			
			$cmd = './lcd2usb '.$trackinfo.' '.sprintf('%c',$extrachar);

			//$nloc = sprintf('%d:%02d',,;
			//$tloc = sprintf('%d:%02d',floor($mpd->current_track_length/60),$mpd->current_track_length%60);
			printf($cmd."\n");
			shell_exec($cmd);
			//$loc = "Location: $nloc/$tloc";
		} else {
			$cmd = './lcd2usb --stop '.sprintf('%c',$extrachar);
			printf($cmd."\n");
			shell_exec($cmd);
		}
	}
	usleep(200);
}


?>
